-- 十连自选
Lua_TenRecruitSelectWindow = class("Lua_TenRecruitSelectWindow", Lua_Window);
function Lua_TenRecruitSelectWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TenRecruitSelectWindow";
	self.skinName = "TenRecruitSelectWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -479;
end

function Lua_TenRecruitSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsTxt.text = LanUtil.formateStr(202005, tostring(DataCenter.tenRecruitSelectData.limitLv));

	self.rewardList = Lua_DragList.new(self.content, 660, 432, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_TenRecruitSelectShowItem, 220, 432, 1)

	self.infoBg:addClickFuntion(self, self.onBtnCloseClick);

	self:addLuaEvent("UPDATE_TENRECRUITSELECT_INFO", self, self.updateInfo);
	Lua_ProxyManager.getProxy("Lua_TenRecruitSelectProxy"):sTenRecruitSelectInfo();
end

function Lua_TenRecruitSelectWindow:updateInfo()
	local rewardInfo = DataCenter.tenRecruitSelectData.rewardInfo;
	self.rewardList.canDrag = rewardInfo:getSize() > 3;
	self.rewardList:setArrayData(rewardInfo);
end

function Lua_TenRecruitSelectWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	DataCenter.tenRecruitSelectData.isPlay = false;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TenRecruitSelectShowItem = class("Lua_TenRecruitSelectShowItem", Lua_ListCell);
function Lua_TenRecruitSelectShowItem:ctor(p)
	self:superCall("ctor", p, "TenRecruitSelectShowItem_skin");
end

function Lua_TenRecruitSelectShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.receiveBtn:addClickFuntion(self, self.onDrawClick);
	self.checkInfoBtn:addClickFuntion(self, self.onShowRewardClick);
end

function Lua_TenRecruitSelectShowItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tenRecruitSelectData = DataCenter.tenRecruitSelectData;
	if data.extractState == 2 then -- 已抽取
		self.itemBg:setUrl("/images/hero_atlas/"..data.fiveStarHero.path..".png");
		self.campIcon:setAltas("common_altas_2", "xui_common_attribute_"..(data.fiveStarHero.campType + 16).."_n");
		self.nameTxt.text = data.fiveStarHero.name;
		
		if tenRecruitSelectData.draw_state == 0 then -- 不可领取
			self.receiveBtn:setLangValue(202002);
		elseif tenRecruitSelectData.draw_state == 1 then -- 可以领取
			self.receiveBtn:setLangValue(202003);
		elseif tenRecruitSelectData.draw_state == 2 then -- 已领取
			self.receiveBtn:setLangValue(202004);
			self.checkInfoBtn:removeClickFuntion(self, self.onShowRewardClick);
		end
	else
		self.itemBg:setUrl("/images/hero_atlas/ui_hbtj_lh_001.png");
		self.campIcon:setAltas(nil, nil);
		self.nameTxt.text = "";

		if tenRecruitSelectData.draw_state == 2 then -- 已领取
			self.receiveBtn:setLangValue(202004);
			self.checkInfoBtn:removeClickFuntion(self, self.onShowRewardClick);
		else
			self.receiveBtn:setLangValue(202001); -- 免费抽取
		end
	end

	self.itemBg:setGray(data.extractState == 0);
	self.hasDrawObj:SetActive(data.extractState == 2);
	self.receiveBtn:setBtnEnable(not tenRecruitSelectData.draw_state == 2);
	self:showRedDot(data.extractState == 1 or tenRecruitSelectData.draw_state == 1); -- 可以抽取或可以领取
end

function Lua_TenRecruitSelectShowItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(85, -163, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_TenRecruitSelectShowItem:onDrawClick(go)
	if DataCenter.tenRecruitSelectData.draw_state == 2 then
		return;
	end

	if self._data.extractState == 1 then
		Lua_ProxyManager.getProxy("Lua_TenRecruitSelectProxy"):sReceiveReward(self._data.type);
	elseif self._data.extractState == 2 then
		if DataCenter.tenRecruitSelectData.draw_state == 0 then
			OperateAlert.show(LanUtil.formateStr(202005, DataCenter.tenRecruitSelectData.limitLv));
		elseif DataCenter.tenRecruitSelectData.draw_state == 1 then
			Lua_WindowUtil.openWin("Lua_TenRecruitSelectShowRewardWindow", Lua_WinParam.ACTION_OPEN, self._data);
		end
	end
end

function Lua_TenRecruitSelectShowItem:onShowRewardClick(go)
	if DataCenter.tenRecruitSelectData.draw_state ~= 2 then
		Lua_WindowUtil.openWin("Lua_TenRecruitSelectShowRewardWindow", Lua_WinParam.ACTION_OPEN, self._data);
	end
end

function Lua_TenRecruitSelectShowItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end